#!/bin/bash
##
#################################################################################################################################
##                                       																				       ##
## by Alan Gordon - alan@gordon.dk                                                                                             ##
##                                       												                                       ##
## This script is part of a demo for MacSysAdmin 2015, and can be used as a "template" for enabling your own script.           ##
## Its is no where near a final script as it lacs some sanity check, but as written a beginning point.                         ##
## The intended activation method of this script is as a loginhook script. As such a delivery method for it                    ##
## Could be via a PKG that also via a postinstall  script sets this script as a LoginHook script.          				       ##
##                                       																				       ##
#################################################################################################################################

USER=$1
LOCALADMIN="INSERT ADMIN SHORTNAME HERE"
LOCALADMINPASSWORD="INSERT ADMIN PASSWORD HERE"


FVACTIVE=`sudo fdesetup isactive`
FVUSERACTIVE=`fdesetup list  | grep $USER | awk 'BEGIN { FS = "," } ; {print $1}'`


if [ "${FVACTIVE}" == "true" ] && [ $1 == "${FVUSERACTIVE}" ]; then
    echo "FileVault allready active"
    echo "FileVault user active"
    exit 0
fi


# Prevent the Finder from launching
echo '<?xml version="1.0" encoding="UTF-8"?>' > /Users/$1/Library/LaunchAgents/com.apple.Finder.plist
echo '<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">' >> /Users/$1/Library/LaunchAgents/com.apple.Finder.plist
echo '<plist version="1.0">' >> /Users/$1/Library/LaunchAgents/com.apple.Finder.plist
echo '<dict>' >> /Users/$1/Library/LaunchAgents/com.apple.Finder.plist
echo '<key>POSIXSpawnType</key>' >> /Users/$1/Library/LaunchAgents/com.apple.Finder.plist
echo '<string>App</string>' >> /Users/$1/Library/LaunchAgents/com.apple.Finder.plist
echo '<key>RunAtLoad</key>' >> /Users/$1/Library/LaunchAgents/com.apple.Finder.plist
echo '<false/>' >> /Users/$1/Library/LaunchAgents/com.apple.Finder.plist
echo '<key>KeepAlive</key>' >> /Users/$1/Library/LaunchAgents/com.apple.Finder.plist
echo '<dict>' >> /Users/$1/Library/LaunchAgents/com.apple.Finder.plist
echo '<key>SuccessfulExit</key>' >> /Users/$1/Library/LaunchAgents/com.apple.Finder.plist
echo '<false/>' >> /Users/$1/Library/LaunchAgents/com.apple.Finder.plist
echo '<key>AfterInitialDemand</key>' >> /Users/$1/Library/LaunchAgents/com.apple.Finder.plist
echo '<true/>' >> /Users/$1/Library/LaunchAgents/com.apple.Finder.plist
echo '</dict>' >> /Users/$1/Library/LaunchAgents/com.apple.Finder.plist
echo '<key>Label</key>' >> /Users/$1/Library/LaunchAgents/com.apple.Finder.plist
echo '<string>com.apple.Finder</string>' >> /Users/$1/Library/LaunchAgents/com.apple.Finder.plist
echo '<key>Program</key>' >> /Users/$1/Library/LaunchAgents/com.apple.Finder.plist
echo '<string>/var/root/foobar.sh</string>' >> /Users/$1/Library/LaunchAgents/com.apple.Finder.plist
echo '<key>ThrottleInterval</key>' >> /Users/$1/Library/LaunchAgents/com.apple.Finder.plist
echo '<integer>0</integer>' >> /Users/$1/Library/LaunchAgents/com.apple.Finder.plist
echo '</dict>' >> /Users/$1/Library/LaunchAgents/com.apple.Finder.plist
echo '</plist>' >> /Users/$1/Library/LaunchAgents/com.apple.Finder.plist


#  Kill the Dock and prevent it from launching to mimic Kiosk mode
sudo chmod -x /System/Library/CoreServices/Dock.app
sudo killall Dock


# Display dialog asking for the user to enter password for FileVault activation
PASSWORDOK="1"

while [ "$PASSWORDOK" != 0 ] ; do

PASSWORD=`/usr/bin/osascript << EOT

with timeout of 86400 seconds
	tell application "System Events"
		activate
		
		set userpassword to (display dialog "Fulldisk encryption is a requirement of this organisation !
Please enter your password to begin.

Your machine will reboot to complete the process." default answer "" buttons {"Continue"} default button 1 with title "Enter Password" with hidden answer)
		copy (text returned of the result) to the userpassword
		-- set userpassword to "'" & userpassword & "'"
		
	end tell
end timeout
                           
EOT`

dscl "/Local/Default" authonly $USER $PASSWORD
PASSWORDOK=`echo $?`


if [ "$PASSWORDOK" != 0 ] ; then

/usr/bin/osascript << EOT

	tell application "System Events"
	activate
	display dialog "Incorrect password !" buttons {"Continue"} default button 1
	
end tell
                           
EOT

fi

done


# Create plist file for FileVault activation
echo '<?xml version="1.0" encoding="UTF-8"?>' > /tmp/fv_users.plist
echo '<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">' >> /tmp/fv_users.plist
echo '<plist version="1.0">' >> /tmp/fv_users.plist
echo '<dict>' >> /tmp/fv_users.plist
echo '<key>Username</key>' >> /tmp/fv_users.plist
echo "<string>$LOCALADMIN</string>" >> /tmp/fv_users.plist
echo '<key>Password</key>' >> /tmp/fv_users.plist
echo "<string>$LOCALADMINPASSWORD</string>" >> /tmp/fv_users.plist
echo '<key>AdditionalUsers</key>' >> /tmp/fv_users.plist
echo '<array>' >> /tmp/fv_users.plist
echo '<dict>' >> /tmp/fv_users.plist
echo '<key>Username</key>' >> /tmp/fv_users.plist
echo "<string>$USER</string>" >> /tmp/fv_users.plist
echo '<key>Password</key>' >> /tmp/fv_users.plist
echo "<string>$PASSWORD</string>" >> /tmp/fv_users.plist
echo '<key>Certificate</key>' >> /tmp/fv_users.plist
echo '<data>' >> /tmp/fv_users.plist
echo 'INSERT BASE64 ENCODED FILEVAULTMASTER CERTIFICATE HERE' >> /tmp/fv_users.plist
echo '</data>' >> /tmp/fv_users.plist
echo '</dict>' >> /tmp/fv_users.plist
echo '</array>' >> /tmp/fv_users.plist
echo '</dict>' >> /tmp/fv_users.plist
echo '</plist>' >> /tmp/fv_users.plist



# Optional Disable the automatic OS login
#sudo defaults write /Library/Preferences/com.apple.loginwindow DisableFDEAutoLogin -bool YES


# Enable FileVault for users
sudo fdesetup enable -inputplist < /tmp/fv_users.plist -outputplist > /tmp/recoverykey.plist


# Display personal recovery key
PERSONALRECOVERYKEY=`defaults read /tmp/recoverykey.plist RecoveryKey`


if [[ $PERSONALRECOVERYKEY ]] ; then
/usr/bin/osascript << EOT

	tell application "System Events"
	activate
	
	display dialog "Here is your personal recovery key: $PERSONALRECOVERYKEY
Take note of it and store it in a safe place !" buttons {"Continue"} default button 1
	
end tell
                           
EOT

fi

# Optional Set a pre-boot login screen banner
# sudo defaults write /Library/Preferences/com.apple.loginwindow LoginwindowText "MacSysAdmin 2015"
# sudo touch /System/Library/PrivateFrameworks/EFILogin.framework/Resources/EFIResourceBuilder.bundle/Contents/Resources


# Enable the Finder
sudo rm /Users/$1/Library/LaunchAgents/com.apple.Finder.plist


# Enable the Dock
sudo chmod +x /System/Library/CoreServices/Dock.app


# Disable loginhook and reboot
sudo defaults write /Library/Preferences/com.apple.loginwindow LoginHook
sudo srm /Library/FileVault/FileVault_enable.sh
sudo srm /tmp/`hostname -s`-recoverykey.txt

sudo reboot

exit 0